import { Observable } from 'rxjs';
import { Args, FetchResult } from './types';
/**
 * fetch wrapper
 *
 * parameter init ignored during parameter input is typeof Request
 */
export declare function _fetch(input: Request | string, args: Args, requestInit: RequestInit): FetchResult<Response>;
/** Create Observable Request */
export declare function createObbRequest(input: Request | string, args: Args, requestInit: RequestInit): FetchResult<Response>;
export declare function parseRequestStream(request$: Observable<Response>, args: Args): FetchResult<Response>;
/**
 * Handle redirect case to retrieve cookies before jumping under Node.js.
 * There's no effect under Browser
 *
 * docs: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status
 */
export declare function handleRedirect(resp: Response, args: Args, init: RequestInit): FetchResult<Response>;
