/**
 * rxxfetch
 * Observable HTTP fetch API for browser and Node.js. Handle 302/303 redirect correctly on Node.js
 *
 * @version 12.5.1
 * @author waiting
 * @license MIT
 * @link https://waitingsong.github.io/rxxfetch/
 */
import{throwError as e,of as t,defer as n}from"rxjs";import{catchError as o,map as r,concatMap as s,timeout as a}from"rxjs/operators";import{abortableFetch as i,AbortController as c}from"abortcontroller-polyfill/dist/cjs-ponyfill.js";import f,{Headers as u}from"node-fetch";import d from"form-data";import l from"qs";const p={dataType:"json",keepRedirectCookies:!1,method:"GET",processData:!0,timeout:null,cache:"default",credentials:"same-origin",mode:"cors",redirect:"follow",referrer:"client"};"undefined"==typeof window&&("function"!=typeof fetch&&(p.fetchModule=i(f).fetch),"function"!=typeof Headers&&(p.headersInitClass=u));const y="Fetch error status:";function h(t){return e((()=>new Error("Assert Never Unexpected object: "+t)))}function b(e,s=!1){if(e.ok||s)return t(e);const{status:a,statusText:i}=e;return n((()=>e.text())).pipe(o((e=>t(JSON.stringify(e)))),r((e=>{const t=undefined;throw new Error(`Fetch error status:${a}\nstatusText: ${i}\nResponse: ${e}`)})))}function m(e,o){let r;switch(o){case"arrayBuffer":r=n((()=>e.arrayBuffer()));break;case"bare":r=t(e);break;case"blob":r=n((()=>e.blob()));break;case"formData":r=n((()=>e.formData()));break;case"json":r=n((()=>e.json()));break;case"raw":r=t(e);break;case"text":r=n((()=>e.text()));break;default:return h(o)}return r}function g(e){if(!e)return;const t=e.split(/;/),n={};for(let e of t){if(e=e.trim(),!e)continue;if(!e.includes("="))continue;if(e.startsWith("Path="))continue;const[t,o]=e.split("=");t&&o&&(n[t]=o)}return n&&Object.keys(n).length?n:void 0}var T;function j(e,t){if(t&&"object"==typeof t&&Object.keys(t).length){const n=l.stringify(t);return e.includes("?")?`${e}&${n}`:`${e}?${n}`}return e}function C(e){const t=Object.assign({},e),n={};return"undefined"!=typeof t.cookies&&(n.cookies=t.cookies),delete t.cookies,t.abortController&&"function"==typeof t.abortController.abort&&(n.abortController=t.abortController),delete t.abortController,"undefined"!=typeof t.contentType&&(n.contentType=t.contentType),delete t.contentType,"undefined"!=typeof t.data&&(n.data=t.data),delete t.data,t.dataType&&(n.dataType=t.dataType),delete t.dataType,t.fetchModule&&(n.fetchModule=t.fetchModule),delete t.fetchModule,t.headersInitClass&&(n.headersInitClass=t.headersInitClass),delete t.headersInitClass,"undefined"!=typeof t.keepRedirectCookies&&(n.keepRedirectCookies=!!t.keepRedirectCookies),delete t.keepRedirectCookies,"undefined"!=typeof t.processData&&(n.processData=t.processData),delete t.processData,"undefined"!=typeof t.timeout&&(n.timeout=t.timeout),delete t.timeout,{args:n,requestInit:Object.assign({},t)}}function k(e){let t=Object.assign({},e);return t=w(t),t=O(t),t=E(t),t=I(t),t.args.dataType=D(t.args.dataType),t.args.timeout=q(t.args.timeout),t.requestInit.redirect=x(t.args.keepRedirectCookies,t.requestInit.redirect),t}function w(e){const{args:t,requestInit:n}=e;if(t.headersInitClass){const e=n.headers?new t.headersInitClass(n.headers):new t.headersInitClass;n.headers=e}else{if("function"!=typeof Headers)throw new TypeError('parseHeaders(): Headers Class undefined.\nIf running under Node.js, it must pass HeaderClass such come from package "node-fetch".');n.headers=n.headers?new Headers(n.headers):new Headers}const{headers:o}=n;return o.has("Accept")||o.set("Accept","application/json, text/html, text/javascript, text/plain, */*"),{args:t,requestInit:n}}function O(e){const{args:t,requestInit:n}=e;return t.abortController&&t.abortController.signal&&"function"==typeof t.abortController.abort||(t.abortController="function"==typeof AbortController?new AbortController:new c),t.abortController&&(n.signal=t.abortController.signal),{args:t,requestInit:n}}function E(e){const{args:t,requestInit:n}=e,o=t.cookies,r=[];if(o&&"object"==typeof o)for(let[e,t]of Object.entries(o))if(e&&"string"==typeof e){if(e=e.trim(),!e)continue;t="string"==typeof t||"number"==typeof t?t.toString().trim():"",r.push(`${e}=${t}`)}if(r.length){const e=n.headers;let t=e.get("Cookie");if(t){t=t.trim();let n=r.join("; ");t.endsWith(";")?(t=t.slice(0,-1),n=`${t}; `+n):n=`${t}; `+n,e.set("Cookie",n)}else e.set("Cookie",r.join("; "))}return{args:t,requestInit:n}}function I(e){const{args:t,requestInit:n}=e;if(n.method&&["DELETE","POST","PUT"].includes(n.method)){const e=n.headers;!1===t.contentType||(t.contentType?e.set("Content-Type",t.contentType):e.has("Content-Type")||e.set("Content-Type",T.json))}return{args:t,requestInit:n}}function D(e){return"string"==typeof e&&["arrayBuffer","bare","blob","formData","json","text","raw"].includes(e)?e:"json"}function q(e){const t="number"==typeof e&&e>=0?Math.ceil(e):null;return null!==t&&Number.isSafeInteger(t)?t:null}function x(e,t){return!0===e&&"undefined"==typeof window&&"follow"===t?"manual":t||"follow"}function P(t){let n=null;return t?("function"!=typeof t&&e((()=>new TypeError("fetchModule is not Function"))),n=t):"function"==typeof fetch?n=fetch:e((()=>new TypeError("fetchModule/fetch not Function"))),n}function S(e,t){let n="";if("undefined"==typeof t.data)n=e;else{if(!t.processData)throw new TypeError("Typeof args.data invalid for GET/DELETE when args.processData not true, type is :"+typeof t.data);n=j(e,t.data)}return n}function R(e){let t;const{data:n}=e;return"string"==typeof n?t=n:"undefined"==typeof n||null===n||(t="undefined"!=typeof FormData&&n instanceof FormData||"undefined"!=typeof d&&n instanceof d||"undefined"!=typeof Blob&&n instanceof Blob||"undefined"!=typeof ArrayBuffer&&n instanceof ArrayBuffer||"undefined"!=typeof URLSearchParams&&n instanceof URLSearchParams||"undefined"!=typeof ReadableStream&&n instanceof ReadableStream?n:e.processData&&e.contentType&&e.contentType.includes("json")?JSON.stringify(n):e.processData?l.stringify(n):n),t}function v(t,n,o){t||e((()=>new TypeError("value of input invalid")));let r=$(t,n,o);return r=M(r,n),r.pipe(s((e=>H(e,n,o))))}function $(e,t,o){let r=e;const s=P(t.fetchModule);if("string"==typeof e){if(["GET","DELETE"].includes(o.method))r=S(e,t);else{if(!["POST","PUT","OPTIONS"].includes(o.method))throw new TypeError(`Invalid method value: "${o.method}"`);{const e=R(t);"undefined"!=typeof e&&(o.body=e)}}return n((()=>s(r,o)))}return n((()=>s(e)))}function M(e,t){const n=undefined;return A(e,t.timeout,t.abortController)}function A(e,t,n){let r=e;return"number"==typeof t&&t>=0&&(r=e.pipe(a(t),o((e=>{throw n&&"function"==typeof n.abort&&!n.signal.aborted&&n.abort(),e})))),r}function H(n,o,r){if(!0===o.keepRedirectCookies&&n.status>=301&&n.status<=308){const e=n.headers.get("location"),t=n.headers.get("Set-Cookie");if(e){const s=g(t);s&&(o.cookies=o.cookies?Object.assign(Object.assign({},o.cookies),s):Object.assign({},s));const a=k({args:o,requestInit:r});return 303===n.status?(a.requestInit.method="GET",v(e,a.args,a.requestInit)):v(e,a.args,a.requestInit)}}else e((()=>"Redirect location is empty"));return t(n)}function U(t,n){t||e((()=>new TypeError("value of input invalid")));const o=undefined,r=C(n?Object.assign(Object.assign({},p),n):Object.assign({},p)),{args:a,requestInit:i}=k(r),c=a.dataType,f=undefined,u=undefined;return v(t,a,i).pipe(s((e=>b(e,"bare"===c))),s((e=>m(e,c))))}function B(e,t){const n=undefined;return U(e,t?Object.assign(Object.assign({},t),{method:"GET"}):{method:"GET"})}function L(e,t){const n=undefined;return U(e,t?Object.assign(Object.assign({},t),{method:"POST"}):{method:"POST"})}function F(e,t){const n=undefined;return U(e,t?Object.assign(Object.assign({},t),{method:"PUT"}):{method:"PUT"})}function G(e,t){const n=undefined;return U(e,t?Object.assign(Object.assign({},t),{method:"DELETE"}):{method:"DELETE"})}function N(e){for(const[t,n]of Object.entries(e))Object.defineProperty(p,t,{configurable:!0,enumerable:!0,writable:!0,value:n})}function J(){return Object.assign({},p)}!function(e){e.formDataPartial="multipart/form-data; boundary=",e.formUrlencoded="application/x-www-form-urlencoded; charset=utf-8",e.html="text/html; charset=utf-8",e.json="application/json; charset=utf-8",e.plain="text/plain"}(T||(T={}));export{T as ContentTypeList,j as buildQueryString,U as fetch,B as get,J as getGloalRequestInit,k as parseInitOpts,S as parseRequestGetLikeData,R as parseRequestPostLikeData,g as parseRespCookie,L as post,F as put,G as remove,U as rxfetch,P as selectFecthModule,N as setGloalRequestInit,C as splitInitArgs};
//# sourceMappingURL=rxxfetch.esm.min.js.map
