/**
 * rxxfetch
 * Observable HTTP fetch API for browser and Node.js. Handle 302/303 redirect correctly on Node.js
 *
 * @version 12.5.1
 * @author waiting
 * @license MIT
 * @link https://waitingsong.github.io/rxxfetch/
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define("rxxfetch",["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).rxxfetch={})}(this,(function(e){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */var t=function(e,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])})(e,r)};function r(e,r){if("function"!=typeof r&&null!==r)throw new TypeError("Class extends value "+String(r)+" is not a constructor or null");function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}function n(e,t,r,n){function o(e){return e instanceof r?e:new r((function(t){t(e)}))}return new(r||(r=Promise))((function(r,i){function a(e){try{c(n.next(e))}catch(e){i(e)}}function u(e){try{c(n.throw(e))}catch(e){i(e)}}function c(e){e.done?r(e.value):o(e.value).then(a,u)}c((n=n.apply(e,t||[])).next())}))}function o(e,t){var r={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]},n,o,i,a;return a={next:u(0),throw:u(1),return:u(2)},"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function u(e){return function(t){return c([e,t])}}function c(a){if(n)throw new TypeError("Generator is already executing.");for(;r;)try{if(n=1,o&&(i=2&a[0]?o.return:a[0]?o.throw||((i=o.return)&&i.call(o),0):o.next)&&!(i=i.call(o,a[1])).done)return i;switch(o=0,i&&(a=[2&a[0],i.value]),a[0]){case 0:case 1:i=a;break;case 4:return r.label++,{value:a[1],done:!1};case 5:r.label++,o=a[1],a=[0];continue;case 7:a=r.ops.pop(),r.trys.pop();continue;default:if(!(i=r.trys,(i=i.length>0&&i[i.length-1])||6!==a[0]&&2!==a[0])){r=0;continue}if(3===a[0]&&(!i||a[1]>i[0]&&a[1]<i[3])){r.label=a[1];break}if(6===a[0]&&r.label<i[1]){r.label=i[1],i=a;break}if(i&&r.label<i[2]){r.label=i[2],r.ops.push(a);break}i[2]&&r.ops.pop(),r.trys.pop();continue}a=t.call(e,r)}catch(e){a=[6,e],o=0}finally{n=i=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}}function i(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function a(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n=r.call(e),o,i=[],a;try{for(;(void 0===t||t-- >0)&&!(o=n.next()).done;)i.push(o.value)}catch(e){a={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(a)throw a.error}}return i}function u(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e}function c(e){return this instanceof c?(this.v=e,this):new c(e)}function s(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n=r.apply(e,t||[]),o,i=[];return o={},a("next"),a("throw"),a("return"),o[Symbol.asyncIterator]=function(){return this},o;function a(e){n[e]&&(o[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||u(e,t)}))})}function u(e,t){try{s(n[e](t))}catch(e){p(i[0][3],e)}}function s(e){e.value instanceof c?Promise.resolve(e.value.v).then(f,l):p(i[0][2],e)}function f(e){u("next",e)}function l(e){u("throw",e)}function p(e,t){e(t),i.shift(),i.length&&u(i[0][0],i[0][1])}}function f(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=e[Symbol.asyncIterator],r;return t?t.call(e):(e="function"==typeof i?i(e):e[Symbol.iterator](),r={},n("next"),n("throw"),n("return"),r[Symbol.asyncIterator]=function(){return this},r);function n(t){r[t]=e[t]&&function(r){return new Promise((function(n,i){o(n,i,(r=e[t](r)).done,r.value)}))}}function o(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}}function l(e){return"function"==typeof e}function p(e){var t,r=e((function(e){Error.call(e),e.stack=(new Error).stack}));return r.prototype=Object.create(Error.prototype),r.prototype.constructor=r,r}var y=p((function(e){return function t(r){e(this),this.message=r?r.length+" errors occurred during unsubscription:\n"+r.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=r}}));function d(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}var h=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._teardowns=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,n,o;if(!this.closed){this.closed=!0;var c=this._parentage;if(c)if(this._parentage=null,Array.isArray(c))try{for(var s=i(c),f=s.next();!f.done;f=s.next()){var p;f.value.remove(this)}}catch(t){e={error:t}}finally{try{f&&!f.done&&(t=s.return)&&t.call(s)}finally{if(e)throw e.error}}else c.remove(this);var d=this.initialTeardown;if(l(d))try{d()}catch(e){o=e instanceof y?e.errors:[e]}var h=this._teardowns;if(h){this._teardowns=null;try{for(var b=i(h),g=b.next();!g.done;g=b.next()){var m=g.value;try{v(m)}catch(e){o=null!=o?o:[],e instanceof y?o=u(u([],a(o)),a(e.errors)):o.push(e)}}}catch(e){r={error:e}}finally{try{g&&!g.done&&(n=b.return)&&n.call(b)}finally{if(r)throw r.error}}}if(o)throw new y(o)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)v(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._teardowns=null!==(r=this._teardowns)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&d(t,e)},e.prototype.remove=function(t){var r=this._teardowns;r&&d(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function b(e){return e instanceof h||e&&"closed"in e&&l(e.remove)&&l(e.add)&&l(e.unsubscribe)}function v(e){l(e)?e():e.unsubscribe()}var g={onUnhandledError:null,onStoppedNotification:null,Promise:void 0,useDeprecatedSynchronousErrorHandling:!1,useDeprecatedNextContext:!1},m=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return setTimeout.apply(void 0,u([],a(e)))},w=function(e){return clearTimeout(e)},S=void 0;function O(e){m((function(){throw e}))}function j(){}var P=function(e){function t(t){var r=e.call(this)||this;return r.isStopped=!1,t?(r.destination=t,b(t)&&t.add(r)):r.destination=_,r}return r(t,e),t.create=function(e,t,r){return new A(e,t,r)},t.prototype.next=function(e){this.isStopped||this._next(e)},t.prototype.error=function(e){this.isStopped||(this.isStopped=!0,this._error(e))},t.prototype.complete=function(){this.isStopped||(this.isStopped=!0,this._complete())},t.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},t.prototype._next=function(e){this.destination.next(e)},t.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},t.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},t}(h),A=function(e){function t(t,r,n){var o=e.call(this)||this,i;if(l(t))i=t;else if(t){var a;i=t.next,r=t.error,n=t.complete,o&&g.useDeprecatedNextContext?(a=Object.create(t)).unsubscribe=function(){return o.unsubscribe()}:a=t,i=null==i?void 0:i.bind(a),r=null==r?void 0:r.bind(a),n=null==n?void 0:n.bind(a)}return o.destination={next:i?E(i):j,error:E(null!=r?r:x),complete:n?E(n):j},o}return r(t,e),t}(P);function E(e,t){return function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];try{e.apply(void 0,u([],a(t)))}catch(e){O(e)}}}function x(e){throw e}var _={closed:!0,next:j,error:x,complete:j},k="function"==typeof Symbol&&Symbol.observable||"@@observable";function T(e){return e}function I(e){return 0===e.length?T:1===e.length?e[0]:function t(r){return e.reduce((function(e,t){return t(e)}),r)}}var R=function(){function e(e){e&&(this._subscribe=e)}return e.prototype.lift=function(t){var r=new e;return r.source=this,r.operator=t,r},e.prototype.subscribe=function(e,t,r){var n=D(e)?e:new A(e,t,r),o=this,i=o.operator,a=o.source;return n.add(i?i.call(n,a):a?this._subscribe(n):this._trySubscribe(n)),n},e.prototype._deprecatedSyncErrorSubscribe=function(e){var t=e;t._syncErrorHack_isSubscribing=!0;var r=this.operator;if(r)e.add(r.call(e,this.source));else try{e.add(this._subscribe(e))}catch(e){t.__syncError=e}for(var n=t;n;){if("__syncError"in n)try{throw n.__syncError}finally{e.unsubscribe()}n=n.destination}t._syncErrorHack_isSubscribing=!1},e.prototype._trySubscribe=function(e){try{return this._subscribe(e)}catch(t){e.error(t)}},e.prototype.forEach=function(e,t){var r=this;return new(t=C(t))((function(t,n){var o;o=r.subscribe((function(t){try{e(t)}catch(e){n(e),null==o||o.unsubscribe()}}),n,t)}))},e.prototype._subscribe=function(e){var t;return null===(t=this.source)||void 0===t?void 0:t.subscribe(e)},e.prototype[k]=function(){return this},e.prototype.pipe=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return e.length?I(e)(this):this},e.prototype.toPromise=function(e){var t=this;return new(e=C(e))((function(e,r){var n;t.subscribe((function(e){return n=e}),(function(e){return r(e)}),(function(){return e(n)}))}))},e.create=function(t){return new e(t)},e}();function C(e){var t;return null!==(t=null!=e?e:g.Promise)&&void 0!==t?t:Promise}function F(e){return e&&l(e.next)&&l(e.error)&&l(e.complete)}function D(e){return e&&e instanceof P||F(e)&&b(e)}function L(e){return l(null==e?void 0:e.lift)}function N(e){return function(t){if(L(t))return t.lift((function(t){try{return e(t,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")}}var M=function(e){function t(t,r,n,o,i){var a=e.call(this,t)||this;return a.onFinalize=i,a._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,a._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,a._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,a}return r(t,e),t.prototype.unsubscribe=function(){var t,r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))},t}(P),U=function(){return Date.now()},q=void 0,B=function(e){function t(t,r){return e.call(this)||this}return r(t,e),t.prototype.schedule=function(e,t){return this},t}(h),W=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return setInterval.apply(void 0,u([],a(e)))},H=function(e){return clearInterval(e)},G=void 0,$=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.scheduler=t,n.work=r,n.pending=!1,n}return r(t,e),t.prototype.schedule=function(e,t){if(void 0===t&&(t=0),this.closed)return this;this.state=e;var r=this.id,n=this.scheduler;return null!=r&&(this.id=this.recycleAsyncId(n,r,t)),this.pending=!0,this.delay=t,this.id=this.id||this.requestAsyncId(n,this.id,t),this},t.prototype.requestAsyncId=function(e,t,r){return void 0===r&&(r=0),W(e.flush.bind(e,this),r)},t.prototype.recycleAsyncId=function(e,t,r){if(void 0===r&&(r=0),null!=r&&this.delay===r&&!1===this.pending)return t;H(t)},t.prototype.execute=function(e,t){if(this.closed)return new Error("executing a cancelled action");this.pending=!1;var r=this._execute(e,t);if(r)return r;!1===this.pending&&null!=this.id&&(this.id=this.recycleAsyncId(this.scheduler,this.id,null))},t.prototype._execute=function(e,t){var r=!1,n;try{this.work(e)}catch(e){r=!0,n=!!e&&e||new Error(e)}if(r)return this.unsubscribe(),n},t.prototype.unsubscribe=function(){if(!this.closed){var t=this,r=t.id,n=t.scheduler,o=n.actions;this.work=this.state=this.scheduler=null,this.pending=!1,d(o,this),null!=r&&(this.id=this.recycleAsyncId(n,r,null)),this.delay=null,e.prototype.unsubscribe.call(this)}},t}(B),z=function(){function e(t,r){void 0===r&&(r=e.now),this.schedulerActionCtor=t,this.now=r}return e.prototype.schedule=function(e,t,r){return void 0===t&&(t=0),new this.schedulerActionCtor(this,e).schedule(r,t)},e.now=U,e}(),V,Q=new(function(e){function t(t,r){void 0===r&&(r=z.now);var n=e.call(this,t,r)||this;return n.actions=[],n._active=!1,n._scheduled=void 0,n}return r(t,e),t.prototype.flush=function(e){var t=this.actions;if(this._active)t.push(e);else{var r;this._active=!0;do{if(r=e.execute(e.state,e.delay))break}while(e=t.shift());if(this._active=!1,r){for(;e=t.shift();)e.unsubscribe();throw r}}},t}(z))($);function J(e,t){return new R((function(r){var n=0;return t.schedule((function(){n===e.length?r.complete():(r.next(e[n++]),r.closed||this.schedule())}))}))}var Y=function(e){return e&&"number"==typeof e.length&&"function"!=typeof e};function K(e){return l(null==e?void 0:e.then)}function X(){return"function"==typeof Symbol&&Symbol.iterator?Symbol.iterator:"@@iterator"}var Z=X();function ee(e,t,r,n){void 0===n&&(n=0);var o=t.schedule((function(){try{r.call(this)}catch(t){e.error(t)}}),n);return e.add(o),o}function te(e){return l(e[k])}function re(e){return l(null==e?void 0:e[Z])}function ne(e){return Symbol.asyncIterator&&l(null==e?void 0:e[Symbol.asyncIterator])}function oe(e){return new TypeError("You provided "+(null!==e&&"object"==typeof e?"an invalid object":"'"+e+"'")+" where a stream was expected. You can provide an Observable, Promise, ReadableStream, Array, AsyncIterable, or Iterable.")}function ie(e){return s(this,arguments,(function t(){var r,n,i,a;return o(this,(function(t){switch(t.label){case 0:r=e.getReader(),t.label=1;case 1:t.trys.push([1,,9,10]),t.label=2;case 2:return[4,c(r.read())];case 3:return n=t.sent(),i=n.value,(a=n.done)?[4,c(void 0)]:[3,5];case 4:return[2,t.sent()];case 5:return[4,c(i)];case 6:return[4,t.sent()];case 7:return t.sent(),[3,2];case 8:return[3,10];case 9:return r.releaseLock(),[7];case 10:return[2]}}))}))}function ae(e){return l(null==e?void 0:e.getReader)}function ue(e){if(e instanceof R)return e;if(null!=e){if(te(e))return ce(e);if(Y(e))return se(e);if(K(e))return fe(e);if(ne(e))return pe(e);if(re(e))return le(e);if(ae(e))return ye(e)}throw oe(e)}function ce(e){return new R((function(t){var r=e[k]();if(l(r.subscribe))return r.subscribe(t);throw new TypeError("Provided object does not correctly implement Symbol.observable")}))}function se(e){return new R((function(t){for(var r=0;r<e.length&&!t.closed;r++)t.next(e[r]);t.complete()}))}function fe(e){return new R((function(t){e.then((function(e){t.closed||(t.next(e),t.complete())}),(function(e){return t.error(e)})).then(null,O)}))}function le(e){return new R((function(t){var r,n;try{for(var o=i(e),a=o.next();!a.done;a=o.next()){var u=a.value;if(t.next(u),t.closed)return}}catch(e){r={error:e}}finally{try{a&&!a.done&&(n=o.return)&&n.call(o)}finally{if(r)throw r.error}}t.complete()}))}function pe(e){return new R((function(t){de(e,t).catch((function(e){return t.error(e)}))}))}function ye(e){return pe(ie(e))}function de(e,t){var r,i,a,u;return n(this,void 0,void 0,(function(){var n,c;return o(this,(function(o){switch(o.label){case 0:o.trys.push([0,5,6,11]),r=f(e),o.label=1;case 1:return[4,r.next()];case 2:if((i=o.sent()).done)return[3,4];if(n=i.value,t.next(n),t.closed)return[2];o.label=3;case 3:return[3,1];case 4:return[3,11];case 5:return c=o.sent(),a={error:c},[3,11];case 6:return o.trys.push([6,,9,10]),i&&!i.done&&(u=r.return)?[4,u.call(r)]:[3,8];case 7:o.sent(),o.label=8;case 8:return[3,10];case 9:if(a)throw a.error;return[7];case 10:return[7];case 11:return t.complete(),[2]}}))}))}function he(e,t){return t?J(e,t):se(e)}function be(e){return e&&l(e.schedule)}function ve(e){return e[e.length-1]}function ge(e){return be(ve(e))?e.pop():void 0}function me(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=ge(e);return r?J(e,r):he(e)}function we(e,t){var r=l(e)?e:function(){return e},n=function(e){return e.error(r())};return new R(t?function(e){return t.schedule(n,0,e)}:n)}function Se(e){return e instanceof Date&&!isNaN(e)}var Oe=p((function(e){return function t(r){void 0===r&&(r=null),e(this),this.message="Timeout has occurred",this.name="TimeoutError",this.info=r}}));function je(e,t){var r=Se(e)?{first:e}:"number"==typeof e?{each:e}:e,n=r.first,o=r.each,i=r.with,a=void 0===i?Pe:i,u=r.scheduler,c=void 0===u?null!=t?t:Q:u,s=r.meta,f=void 0===s?null:s;if(null==n&&null==o)throw new TypeError("No timeout provided.");return N((function(e,t){var r,i,u=null,s=0,l=function(e){i=ee(t,c,(function(){r.unsubscribe(),ue(a({meta:f,lastValue:u,seen:s})).subscribe(t)}),e)};r=e.subscribe(new M(t,(function(e){null==i||i.unsubscribe(),s++,t.next(u=e),o>0&&l(o)}),void 0,void 0,(function(){(null==i?void 0:i.closed)||null==i||i.unsubscribe(),u=null}))),l(null!=n?"number"==typeof n?n:+n-c.now():o)}))}function Pe(e){throw new Oe(e)}function Ae(e,t){return N((function(r,n){var o=0;r.subscribe(new M(n,(function(r){n.next(e.call(t,r,o++))})))}))}function Ee(e,t,r,n,o,i,a,u){var c=[],s=0,f=0,l=!1,p=function(){!l||c.length||s||t.complete()},y=function(e){return s<n?d(e):c.push(e)},d=function(e){i&&t.next(e),s++;var u=!1;ue(r(e,f++)).subscribe(new M(t,(function(e){null==o||o(e),i?y(e):t.next(e)}),(function(){u=!0}),void 0,(function(){if(u)try{s--;for(var e=function(){var e=c.shift();a?t.add(a.schedule((function(){return d(e)}))):d(e)};c.length&&s<n;)e();p()}catch(e){t.error(e)}})))};return e.subscribe(new M(t,y,(function(){l=!0,p()}))),function(){null==u||u()}}function xe(e,t,r){return void 0===r&&(r=1/0),l(t)?xe((function(r,n){return Ae((function(e,o){return t(r,e,n,o)}))(ue(e(r,n)))}),r):("number"==typeof t&&(r=t),N((function(t,n){return Ee(t,n,e,r)})))}function _e(e){return new R((function(t){ue(e()).subscribe(t)}))}function ke(e){return N((function(t,r){var n=null,o=!1,i;n=t.subscribe(new M(r,void 0,void 0,(function(a){i=ue(e(a,ke(e)(t))),n?(n.unsubscribe(),n=null,i.subscribe(r)):o=!0}))),o&&(n.unsubscribe(),n=null,i.subscribe(r))}))}function Te(e,t){return l(t)?xe(e,t,1):xe(e,1)}function Ie(e){if(e.__esModule)return e;var t=Object.defineProperty({},"__esModule",{value:!0});return Object.keys(e).forEach((function(r){var n=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,n.get?n:{enumerable:!0,get:function(){return e[r]}})})),t}var Re={};function Ce(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Fe(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function De(e,t,r){return t&&Fe(e.prototype,t),r&&Fe(e,r),e}function Le(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Me(e,t)}function Ne(e){return(Ne=Object.setPrototypeOf?Object.getPrototypeOf:function e(t){return t.__proto__||Object.getPrototypeOf(t)})(e)}function Me(e,t){return(Me=Object.setPrototypeOf||function e(t,r){return t.__proto__=r,t})(e,t)}function Ue(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}function qe(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function Be(e,t){return!t||"object"!=typeof t&&"function"!=typeof t?qe(e):t}function We(e){var t=Ue();return function r(){var n=Ne(e),o;if(t){var i=Ne(this).constructor;o=Reflect.construct(n,arguments,i)}else o=n.apply(this,arguments);return Be(this,o)}}function He(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=Ne(e)););return e}function Ge(e,t,r){return(Ge="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function e(t,r,n){var o=He(t,r);if(o){var i=Object.getOwnPropertyDescriptor(o,r);return i.get?i.get.call(n):i.value}})(e,t,r||e)}Object.defineProperty(Re,"__esModule",{value:!0});var $e=function(){function e(){Ce(this,e),Object.defineProperty(this,"listeners",{value:{},writable:!0,configurable:!0})}return De(e,[{key:"addEventListener",value:function e(t,r,n){t in this.listeners||(this.listeners[t]=[]),this.listeners[t].push({callback:r,options:n})}},{key:"removeEventListener",value:function e(t,r){if(t in this.listeners)for(var n=this.listeners[t],o=0,i=n.length;o<i;o++)if(n[o].callback===r)return void n.splice(o,1)}},{key:"dispatchEvent",value:function e(t){if(t.type in this.listeners){for(var r,n=this.listeners[t.type].slice(),o=0,i=n.length;o<i;o++){var a=n[o];try{a.callback.call(this,t)}catch(e){Promise.resolve().then((function(){throw e}))}a.options&&a.options.once&&this.removeEventListener(t.type,a.callback)}return!t.defaultPrevented}}}]),e}(),ze=function(e){Le(r,e);var t=We(r);function r(){var e;return Ce(this,r),(e=t.call(this)).listeners||$e.call(qe(e)),Object.defineProperty(qe(e),"aborted",{value:!1,writable:!0,configurable:!0}),Object.defineProperty(qe(e),"onabort",{value:null,writable:!0,configurable:!0}),e}return De(r,[{key:"toString",value:function e(){return"[object AbortSignal]"}},{key:"dispatchEvent",value:function e(t){"abort"===t.type&&(this.aborted=!0,"function"==typeof this.onabort&&this.onabort.call(this,t)),Ge(Ne(r.prototype),"dispatchEvent",this).call(this,t)}}]),r}($e),Ve=function(){function e(){Ce(this,e),Object.defineProperty(this,"signal",{value:new ze,writable:!0,configurable:!0})}return De(e,[{key:"abort",value:function e(){var t;try{t=new Event("abort")}catch(e){"undefined"!=typeof document?document.createEvent?(t=document.createEvent("Event")).initEvent("abort",!1,!1):(t=document.createEventObject()).type="abort":t={type:"abort",bubbles:!1,cancelable:!1}}this.signal.dispatchEvent(t)}},{key:"toString",value:function e(){return"[object AbortController]"}}]),e}();function Qe(e){return e.__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL?(console.log("__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL=true is set, will force install polyfill"),!0):"function"==typeof e.Request&&!e.Request.prototype.hasOwnProperty("signal")||!e.AbortController}function Je(e){"function"==typeof e&&(e={fetch:e});var t=e,r=t.fetch,n=t.Request,o=void 0===n?r.Request:n,i=t.AbortController,a=t.__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL,u=void 0!==a&&a;if(!Qe({fetch:r,Request:o,AbortController:i,__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL:u}))return{fetch:r,Request:c};var c=o;(c&&!c.prototype.hasOwnProperty("signal")||u)&&((c=function e(t,r){var n;r&&r.signal&&(n=r.signal,delete r.signal);var i=new o(t,r);return n&&Object.defineProperty(i,"signal",{writable:!1,enumerable:!1,configurable:!0,value:n}),i}).prototype=o.prototype);var s=r,f;return{fetch:function e(t,r){var n=c&&c.prototype.isPrototypeOf(t)?t.signal:r?r.signal:void 0;if(n){var o;try{o=new DOMException("Aborted","AbortError")}catch(e){(o=new Error("Aborted")).name="AbortError"}if(n.aborted)return Promise.reject(o);var i=new Promise((function(e,t){n.addEventListener("abort",(function(){return t(o)}),{once:!0})}));return r&&r.signal&&delete r.signal,Promise.race([i,s(t,r)])}return s(t,r)},Request:c}}"undefined"!=typeof Symbol&&Symbol.toStringTag&&(Ve.prototype[Symbol.toStringTag]="AbortController",ze.prototype[Symbol.toStringTag]="AbortSignal");var Ye=Re.AbortController=Ve;Re.AbortSignal=ze;var Ke=Re.abortableFetch=Je,Xe={exports:{}};!function(e,t){var r,n=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;if("undefined"!=typeof n)return n;throw new Error("unable to locate global object")}();e.exports=t=n.fetch,n.fetch&&(t.default=n.fetch.bind(n)),t.Headers=n.Headers,t.Request=n.Request,t.Response=n.Response}(Xe,Xe.exports);var Ze=Xe.exports;const et={dataType:"json",keepRedirectCookies:!1,method:"GET",processData:!0,timeout:null,cache:"default",credentials:"same-origin",mode:"cors",redirect:"follow",referrer:"client"};"undefined"==typeof window&&("function"!=typeof fetch&&(et.fetchModule=Ke(Ze).fetch),"function"!=typeof Headers&&(et.headersInitClass=Xe.exports.Headers));const tt="Fetch error status:";function rt(e){return we((()=>new Error("Assert Never Unexpected object: "+e)))}function nt(e,t=!1){if(e.ok||t)return me(e);const{status:r,statusText:n}=e;return _e((()=>e.text())).pipe(ke((e=>me(JSON.stringify(e)))),Ae((e=>{const t=undefined;throw new Error(`Fetch error status:${r}\nstatusText: ${n}\nResponse: ${e}`)})))}function ot(e,t){let r;switch(t){case"arrayBuffer":r=_e((()=>e.arrayBuffer()));break;case"bare":r=me(e);break;case"blob":r=_e((()=>e.blob()));break;case"formData":r=_e((()=>e.formData()));break;case"json":r=_e((()=>e.json()));break;case"raw":r=me(e);break;case"text":r=_e((()=>e.text()));break;default:return rt(t)}return r}function it(e){if(!e)return;const t=e.split(/;/),r={};for(let e of t){if(e=e.trim(),!e)continue;if(!e.includes("="))continue;if(e.startsWith("Path="))continue;const[t,n]=e.split("=");t&&n&&(r[t]=n)}return r&&Object.keys(r).length?r:void 0}var at="object"==typeof self?self.FormData:window.FormData,ut=function e(){if("function"!=typeof Symbol||"function"!=typeof Object.getOwnPropertySymbols)return!1;if("symbol"==typeof Symbol.iterator)return!0;var t={},r=Symbol("test"),n=Object(r);if("string"==typeof r)return!1;if("[object Symbol]"!==Object.prototype.toString.call(r))return!1;if("[object Symbol]"!==Object.prototype.toString.call(n))return!1;var o=42;for(r in t[r]=o,t)return!1;if("function"==typeof Object.keys&&0!==Object.keys(t).length)return!1;if("function"==typeof Object.getOwnPropertyNames&&0!==Object.getOwnPropertyNames(t).length)return!1;var i=Object.getOwnPropertySymbols(t);if(1!==i.length||i[0]!==r)return!1;if(!Object.prototype.propertyIsEnumerable.call(t,r))return!1;if("function"==typeof Object.getOwnPropertyDescriptor){var a=Object.getOwnPropertyDescriptor(t,r);if(a.value!==o||!0!==a.enumerable)return!1}return!0},ct="undefined"!=typeof Symbol&&Symbol,st=ut,ft=function e(){return"function"==typeof ct&&("function"==typeof Symbol&&("symbol"==typeof ct("foo")&&("symbol"==typeof Symbol("bar")&&st())))},lt="Function.prototype.bind called on incompatible ",pt=Array.prototype.slice,yt=Object.prototype.toString,dt="[object Function]",ht,bt=function e(t){var r=this;if("function"!=typeof r||yt.call(r)!==dt)throw new TypeError(lt+r);for(var n=pt.call(arguments,1),o,i=function(){if(this instanceof o){var e=r.apply(this,n.concat(pt.call(arguments)));return Object(e)===e?e:this}return r.apply(t,n.concat(pt.call(arguments)))},a=Math.max(0,r.length-n.length),u=[],c=0;c<a;c++)u.push("$"+c);if(o=Function("binder","return function ("+u.join(",")+"){ return binder.apply(this,arguments); }")(i),r.prototype){var s=function e(){};s.prototype=r.prototype,o.prototype=new s,s.prototype=null}return o},vt=Function.prototype.bind||bt,gt,mt=vt.call(Function.call,Object.prototype.hasOwnProperty),wt,St=SyntaxError,Ot=Function,jt=TypeError,Pt=function(e){try{return Ot('"use strict"; return ('+e+").constructor;")()}catch(e){}},At=Object.getOwnPropertyDescriptor;if(At)try{At({},"")}catch(e){At=null}var Et=function(){throw new jt},xt=At?function(){try{return Et}catch(e){try{return At(arguments,"callee").get}catch(e){return Et}}}():Et,_t=ft(),kt=Object.getPrototypeOf||function(e){return e.__proto__},Tt={},It="undefined"==typeof Uint8Array?wt:kt(Uint8Array),Rt={"%AggregateError%":"undefined"==typeof AggregateError?wt:AggregateError,"%Array%":Array,"%ArrayBuffer%":"undefined"==typeof ArrayBuffer?wt:ArrayBuffer,"%ArrayIteratorPrototype%":_t?kt([][Symbol.iterator]()):wt,"%AsyncFromSyncIteratorPrototype%":wt,"%AsyncFunction%":Tt,"%AsyncGenerator%":Tt,"%AsyncGeneratorFunction%":Tt,"%AsyncIteratorPrototype%":Tt,"%Atomics%":"undefined"==typeof Atomics?wt:Atomics,"%BigInt%":"undefined"==typeof BigInt?wt:BigInt,"%Boolean%":Boolean,"%DataView%":"undefined"==typeof DataView?wt:DataView,"%Date%":Date,"%decodeURI%":decodeURI,"%decodeURIComponent%":decodeURIComponent,"%encodeURI%":encodeURI,"%encodeURIComponent%":encodeURIComponent,"%Error%":Error,"%eval%":eval,"%EvalError%":EvalError,"%Float32Array%":"undefined"==typeof Float32Array?wt:Float32Array,"%Float64Array%":"undefined"==typeof Float64Array?wt:Float64Array,"%FinalizationRegistry%":"undefined"==typeof FinalizationRegistry?wt:FinalizationRegistry,"%Function%":Ot,"%GeneratorFunction%":Tt,"%Int8Array%":"undefined"==typeof Int8Array?wt:Int8Array,"%Int16Array%":"undefined"==typeof Int16Array?wt:Int16Array,"%Int32Array%":"undefined"==typeof Int32Array?wt:Int32Array,"%isFinite%":isFinite,"%isNaN%":isNaN,"%IteratorPrototype%":_t?kt(kt([][Symbol.iterator]())):wt,"%JSON%":"object"==typeof JSON?JSON:wt,"%Map%":"undefined"==typeof Map?wt:Map,"%MapIteratorPrototype%":"undefined"!=typeof Map&&_t?kt((new Map)[Symbol.iterator]()):wt,"%Math%":Math,"%Number%":Number,"%Object%":Object,"%parseFloat%":parseFloat,"%parseInt%":parseInt,"%Promise%":"undefined"==typeof Promise?wt:Promise,"%Proxy%":"undefined"==typeof Proxy?wt:Proxy,"%RangeError%":RangeError,"%ReferenceError%":ReferenceError,"%Reflect%":"undefined"==typeof Reflect?wt:Reflect,"%RegExp%":RegExp,"%Set%":"undefined"==typeof Set?wt:Set,"%SetIteratorPrototype%":"undefined"!=typeof Set&&_t?kt((new Set)[Symbol.iterator]()):wt,"%SharedArrayBuffer%":"undefined"==typeof SharedArrayBuffer?wt:SharedArrayBuffer,"%String%":String,"%StringIteratorPrototype%":_t?kt(""[Symbol.iterator]()):wt,"%Symbol%":_t?Symbol:wt,"%SyntaxError%":St,"%ThrowTypeError%":xt,"%TypedArray%":It,"%TypeError%":jt,"%Uint8Array%":"undefined"==typeof Uint8Array?wt:Uint8Array,"%Uint8ClampedArray%":"undefined"==typeof Uint8ClampedArray?wt:Uint8ClampedArray,"%Uint16Array%":"undefined"==typeof Uint16Array?wt:Uint16Array,"%Uint32Array%":"undefined"==typeof Uint32Array?wt:Uint32Array,"%URIError%":URIError,"%WeakMap%":"undefined"==typeof WeakMap?wt:WeakMap,"%WeakRef%":"undefined"==typeof WeakRef?wt:WeakRef,"%WeakSet%":"undefined"==typeof WeakSet?wt:WeakSet},Ct=function e(t){var r;if("%AsyncFunction%"===t)r=Pt("async function () {}");else if("%GeneratorFunction%"===t)r=Pt("function* () {}");else if("%AsyncGeneratorFunction%"===t)r=Pt("async function* () {}");else if("%AsyncGenerator%"===t){var n=e("%AsyncGeneratorFunction%");n&&(r=n.prototype)}else if("%AsyncIteratorPrototype%"===t){var o=e("%AsyncGenerator%");o&&(r=kt(o.prototype))}return Rt[t]=r,r},Ft={"%ArrayBufferPrototype%":["ArrayBuffer","prototype"],"%ArrayPrototype%":["Array","prototype"],"%ArrayProto_entries%":["Array","prototype","entries"],"%ArrayProto_forEach%":["Array","prototype","forEach"],"%ArrayProto_keys%":["Array","prototype","keys"],"%ArrayProto_values%":["Array","prototype","values"],"%AsyncFunctionPrototype%":["AsyncFunction","prototype"],"%AsyncGenerator%":["AsyncGeneratorFunction","prototype"],"%AsyncGeneratorPrototype%":["AsyncGeneratorFunction","prototype","prototype"],"%BooleanPrototype%":["Boolean","prototype"],"%DataViewPrototype%":["DataView","prototype"],"%DatePrototype%":["Date","prototype"],"%ErrorPrototype%":["Error","prototype"],"%EvalErrorPrototype%":["EvalError","prototype"],"%Float32ArrayPrototype%":["Float32Array","prototype"],"%Float64ArrayPrototype%":["Float64Array","prototype"],"%FunctionPrototype%":["Function","prototype"],"%Generator%":["GeneratorFunction","prototype"],"%GeneratorPrototype%":["GeneratorFunction","prototype","prototype"],"%Int8ArrayPrototype%":["Int8Array","prototype"],"%Int16ArrayPrototype%":["Int16Array","prototype"],"%Int32ArrayPrototype%":["Int32Array","prototype"],"%JSONParse%":["JSON","parse"],"%JSONStringify%":["JSON","stringify"],"%MapPrototype%":["Map","prototype"],"%NumberPrototype%":["Number","prototype"],"%ObjectPrototype%":["Object","prototype"],"%ObjProto_toString%":["Object","prototype","toString"],"%ObjProto_valueOf%":["Object","prototype","valueOf"],"%PromisePrototype%":["Promise","prototype"],"%PromiseProto_then%":["Promise","prototype","then"],"%Promise_all%":["Promise","all"],"%Promise_reject%":["Promise","reject"],"%Promise_resolve%":["Promise","resolve"],"%RangeErrorPrototype%":["RangeError","prototype"],"%ReferenceErrorPrototype%":["ReferenceError","prototype"],"%RegExpPrototype%":["RegExp","prototype"],"%SetPrototype%":["Set","prototype"],"%SharedArrayBufferPrototype%":["SharedArrayBuffer","prototype"],"%StringPrototype%":["String","prototype"],"%SymbolPrototype%":["Symbol","prototype"],"%SyntaxErrorPrototype%":["SyntaxError","prototype"],"%TypedArrayPrototype%":["TypedArray","prototype"],"%TypeErrorPrototype%":["TypeError","prototype"],"%Uint8ArrayPrototype%":["Uint8Array","prototype"],"%Uint8ClampedArrayPrototype%":["Uint8ClampedArray","prototype"],"%Uint16ArrayPrototype%":["Uint16Array","prototype"],"%Uint32ArrayPrototype%":["Uint32Array","prototype"],"%URIErrorPrototype%":["URIError","prototype"],"%WeakMapPrototype%":["WeakMap","prototype"],"%WeakSetPrototype%":["WeakSet","prototype"]},Dt=vt,Lt=mt,Nt=Dt.call(Function.call,Array.prototype.concat),Mt=Dt.call(Function.apply,Array.prototype.splice),Ut=Dt.call(Function.call,String.prototype.replace),qt=Dt.call(Function.call,String.prototype.slice),Bt=/[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g,Wt=/\\(\\)?/g,Ht=function e(t){var r=qt(t,0,1),n=qt(t,-1);if("%"===r&&"%"!==n)throw new St("invalid intrinsic syntax, expected closing `%`");if("%"===n&&"%"!==r)throw new St("invalid intrinsic syntax, expected opening `%`");var o=[];return Ut(t,Bt,(function(e,t,r,n){o[o.length]=r?Ut(n,Wt,"$1"):t||e})),o},Gt=function e(t,r){var n=t,o;if(Lt(Ft,n)&&(n="%"+(o=Ft[n])[0]+"%"),Lt(Rt,n)){var i=Rt[n];if(i===Tt&&(i=Ct(n)),"undefined"==typeof i&&!r)throw new jt("intrinsic "+t+" exists, but is not available. Please file an issue!");return{alias:o,name:n,value:i}}throw new St("intrinsic "+t+" does not exist!")},$t=function e(t,r){if("string"!=typeof t||0===t.length)throw new jt("intrinsic name must be a non-empty string");if(arguments.length>1&&"boolean"!=typeof r)throw new jt('"allowMissing" argument must be a boolean');var n=Ht(t),o=n.length>0?n[0]:"",i=Gt("%"+o+"%",r),a=i.name,u=i.value,c=!1,s=i.alias;s&&(o=s[0],Mt(n,Nt([0,1],s)));for(var f=1,l=!0;f<n.length;f+=1){var p=n[f],y=qt(p,0,1),d=qt(p,-1);if(('"'===y||"'"===y||"`"===y||'"'===d||"'"===d||"`"===d)&&y!==d)throw new St("property names with quotes must have matching quotes");if("constructor"!==p&&l||(c=!0),Lt(Rt,a="%"+(o+="."+p)+"%"))u=Rt[a];else if(null!=u){if(!(p in u)){if(!r)throw new jt("base intrinsic for "+t+" exists, but the property is not available.");return}if(At&&f+1>=n.length){var h=At(u,p);u=(l=!!h)&&"get"in h&&!("originalValue"in h.get)?h.get:u[p]}else l=Lt(u,p),u=u[p];l&&!c&&(Rt[a]=u)}}return u},zt={exports:{}};!function(e){var t=vt,r=$t,n=r("%Function.prototype.apply%"),o=r("%Function.prototype.call%"),i=r("%Reflect.apply%",!0)||t.call(o,n),a=r("%Object.getOwnPropertyDescriptor%",!0),u=r("%Object.defineProperty%",!0),c=r("%Math.max%");if(u)try{u({},"a",{value:1})}catch(e){u=null}e.exports=function e(r){var n=i(t,o,arguments);if(a&&u){var s=a(n,"length");s.configurable&&u(n,"length",{value:1+c(0,r.length-(arguments.length-1))})}return n};var s=function e(){return i(t,n,arguments)};u?u(e.exports,"apply",{value:s}):e.exports.apply=s}(zt);var Vt=$t,Qt=zt.exports,Jt=Qt(Vt("String.prototype.indexOf")),Yt=function e(t,r){var n=Vt(t,!!r);return"function"==typeof n&&Jt(t,".prototype.")>-1?Qt(n):n},Kt={},Xt,Zt=Ie(Object.freeze({__proto__:null,default:Kt})),er="function"==typeof Map&&Map.prototype,tr=Object.getOwnPropertyDescriptor&&er?Object.getOwnPropertyDescriptor(Map.prototype,"size"):null,rr=er&&tr&&"function"==typeof tr.get?tr.get:null,nr=er&&Map.prototype.forEach,or="function"==typeof Set&&Set.prototype,ir=Object.getOwnPropertyDescriptor&&or?Object.getOwnPropertyDescriptor(Set.prototype,"size"):null,ar=or&&ir&&"function"==typeof ir.get?ir.get:null,ur=or&&Set.prototype.forEach,cr,sr="function"==typeof WeakMap&&WeakMap.prototype?WeakMap.prototype.has:null,fr,lr="function"==typeof WeakSet&&WeakSet.prototype?WeakSet.prototype.has:null,pr,yr="function"==typeof WeakRef&&WeakRef.prototype?WeakRef.prototype.deref:null,dr=Boolean.prototype.valueOf,hr=Object.prototype.toString,br=Function.prototype.toString,vr=String.prototype.match,gr="function"==typeof BigInt?BigInt.prototype.valueOf:null,mr=Object.getOwnPropertySymbols,wr="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?Symbol.prototype.toString:null,Sr="function"==typeof Symbol&&"object"==typeof Symbol.iterator,Or=Object.prototype.propertyIsEnumerable,jr=("function"==typeof Reflect?Reflect.getPrototypeOf:Object.getPrototypeOf)||([].__proto__===Array.prototype?function(e){return e.__proto__}:null),Pr=Zt.custom,Ar=Pr&&Nr(Pr)?Pr:null,Er="function"==typeof Symbol&&"undefined"!=typeof Symbol.toStringTag?Symbol.toStringTag:null,xr=function e(t,r,n,o){var i=r||{};if(qr(i,"quoteStyle")&&"single"!==i.quoteStyle&&"double"!==i.quoteStyle)throw new TypeError('option "quoteStyle" must be "single" or "double"');if(qr(i,"maxStringLength")&&("number"==typeof i.maxStringLength?i.maxStringLength<0&&i.maxStringLength!==1/0:null!==i.maxStringLength))throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');var a=!qr(i,"customInspect")||i.customInspect;if("boolean"!=typeof a)throw new TypeError('option "customInspect", if provided, must be `true` or `false`');if(qr(i,"indent")&&null!==i.indent&&"\t"!==i.indent&&!(parseInt(i.indent,10)===i.indent&&i.indent>0))throw new TypeError('options "indent" must be "\\t", an integer > 0, or `null`');if("undefined"==typeof t)return"undefined";if(null===t)return"null";if("boolean"==typeof t)return t?"true":"false";if("string"==typeof t)return Yr(t,i);if("number"==typeof t)return 0===t?1/0/t>0?"0":"-0":String(t);if("bigint"==typeof t)return String(t)+"n";var u="undefined"==typeof i.depth?5:i.depth;if("undefined"==typeof n&&(n=0),n>=u&&u>0&&"object"==typeof t)return Tr(t)?"[Array]":"[Object]";var c=rn(i,n);if("undefined"==typeof o)o=[];else if(Hr(o,t)>=0)return"[Circular]";function s(t,r,a){if(r&&(o=o.slice()).push(r),a){var u={depth:i.depth};return qr(i,"quoteStyle")&&(u.quoteStyle=i.quoteStyle),e(t,u,n+1,o)}return e(t,i,n+1,o)}if("function"==typeof t){var f=Wr(t),l=on(t,s);return"[Function"+(f?": "+f:" (anonymous)")+"]"+(l.length>0?" { "+l.join(", ")+" }":"")}if(Nr(t)){var p=Sr?String(t).replace(/^(Symbol\(.*\))_[^)]*$/,"$1"):wr.call(t);return"object"!=typeof t||Sr?p:Xr(p)}if(Jr(t)){for(var y="<"+String(t.nodeName).toLowerCase(),d=t.attributes||[],h=0;h<d.length;h++)y+=" "+d[h].name+"="+_r(kr(d[h].value),"double",i);return y+=">",t.childNodes&&t.childNodes.length&&(y+="..."),y+="</"+String(t.nodeName).toLowerCase()+">"}if(Tr(t)){if(0===t.length)return"[]";var b=on(t,s);return c&&!tn(b)?"["+nn(b,c)+"]":"[ "+b.join(", ")+" ]"}if(Cr(t)){var v=on(t,s);return 0===v.length?"["+String(t)+"]":"{ ["+String(t)+"] "+v.join(", ")+" }"}if("object"==typeof t&&a){if(Ar&&"function"==typeof t[Ar])return t[Ar]();if("function"==typeof t.inspect)return t.inspect()}if(Gr(t)){var g=[];return nr.call(t,(function(e,r){g.push(s(r,t,!0)+" => "+s(e,t))})),en("Map",rr.call(t),g,c)}if(Vr(t)){var m=[];return ur.call(t,(function(e){m.push(s(e,t))})),en("Set",ar.call(t),m,c)}if($r(t))return Zr("WeakMap");if(Qr(t))return Zr("WeakSet");if(zr(t))return Zr("WeakRef");if(Dr(t))return Xr(s(Number(t)));if(Mr(t))return Xr(s(gr.call(t)));if(Lr(t))return Xr(dr.call(t));if(Fr(t))return Xr(s(String(t)));if(!Ir(t)&&!Rr(t)){var w=on(t,s),S=jr?jr(t)===Object.prototype:t instanceof Object||t.constructor===Object,O=t instanceof Object?"":"null prototype",j=!S&&Er&&Object(t)===t&&Er in t?Br(t).slice(8,-1):O?"Object":"",P,A=(S||"function"!=typeof t.constructor?"":t.constructor.name?t.constructor.name+" ":"")+(j||O?"["+[].concat(j||[],O||[]).join(": ")+"] ":"");return 0===w.length?A+"{}":c?A+"{"+nn(w,c)+"}":A+"{ "+w.join(", ")+" }"}return String(t)};function _r(e,t,r){var n="double"===(r.quoteStyle||t)?'"':"'";return n+e+n}function kr(e){return String(e).replace(/"/g,"&quot;")}function Tr(e){return!("[object Array]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Ir(e){return!("[object Date]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Rr(e){return!("[object RegExp]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Cr(e){return!("[object Error]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Fr(e){return!("[object String]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Dr(e){return!("[object Number]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Lr(e){return!("[object Boolean]"!==Br(e)||Er&&"object"==typeof e&&Er in e)}function Nr(e){if(Sr)return e&&"object"==typeof e&&e instanceof Symbol;if("symbol"==typeof e)return!0;if(!e||"object"!=typeof e||!wr)return!1;try{return wr.call(e),!0}catch(e){}return!1}function Mr(e){if(!e||"object"!=typeof e||!gr)return!1;try{return gr.call(e),!0}catch(e){}return!1}var Ur=Object.prototype.hasOwnProperty||function(e){return e in this};function qr(e,t){return Ur.call(e,t)}function Br(e){return hr.call(e)}function Wr(e){if(e.name)return e.name;var t=vr.call(br.call(e),/^function\s*([\w$]+)/);return t?t[1]:null}function Hr(e,t){if(e.indexOf)return e.indexOf(t);for(var r=0,n=e.length;r<n;r++)if(e[r]===t)return r;return-1}function Gr(e){if(!rr||!e||"object"!=typeof e)return!1;try{rr.call(e);try{ar.call(e)}catch(e){return!0}return e instanceof Map}catch(e){}return!1}function $r(e){if(!sr||!e||"object"!=typeof e)return!1;try{sr.call(e,sr);try{lr.call(e,lr)}catch(e){return!0}return e instanceof WeakMap}catch(e){}return!1}function zr(e){if(!yr||!e||"object"!=typeof e)return!1;try{return yr.call(e),!0}catch(e){}return!1}function Vr(e){if(!ar||!e||"object"!=typeof e)return!1;try{ar.call(e);try{rr.call(e)}catch(e){return!0}return e instanceof Set}catch(e){}return!1}function Qr(e){if(!lr||!e||"object"!=typeof e)return!1;try{lr.call(e,lr);try{sr.call(e,sr)}catch(e){return!0}return e instanceof WeakSet}catch(e){}return!1}function Jr(e){return!(!e||"object"!=typeof e)&&("undefined"!=typeof HTMLElement&&e instanceof HTMLElement||"string"==typeof e.nodeName&&"function"==typeof e.getAttribute)}function Yr(e,t){if(e.length>t.maxStringLength){var r=e.length-t.maxStringLength,n="... "+r+" more character"+(r>1?"s":"");return Yr(e.slice(0,t.maxStringLength),t)+n}var o;return _r(e.replace(/(['\\])/g,"\\$1").replace(/[\x00-\x1f]/g,Kr),"single",t)}function Kr(e){var t=e.charCodeAt(0),r={8:"b",9:"t",10:"n",12:"f",13:"r"}[t];return r?"\\"+r:"\\x"+(t<16?"0":"")+t.toString(16).toUpperCase()}function Xr(e){return"Object("+e+")"}function Zr(e){return e+" { ? }"}function en(e,t,r,n){var o;return e+" ("+t+") {"+(n?nn(r,n):r.join(", "))+"}"}function tn(e){for(var t=0;t<e.length;t++)if(Hr(e[t],"\n")>=0)return!1;return!0}function rn(e,t){var r;if("\t"===e.indent)r="\t";else{if(!("number"==typeof e.indent&&e.indent>0))return null;r=Array(e.indent+1).join(" ")}return{base:r,prev:Array(t+1).join(r)}}function nn(e,t){if(0===e.length)return"";var r="\n"+t.prev+t.base;return r+e.join(","+r)+"\n"+t.prev}function on(e,t){var r=Tr(e),n=[];if(r){n.length=e.length;for(var o=0;o<e.length;o++)n[o]=qr(e,o)?t(e[o],e):""}var i="function"==typeof mr?mr(e):[],a;if(Sr){a={};for(var u=0;u<i.length;u++)a["$"+i[u]]=i[u]}for(var c in e)qr(e,c)&&(r&&String(Number(c))===c&&c<e.length||Sr&&a["$"+c]instanceof Symbol||(/[^\w$]/.test(c)?n.push(t(c,e)+": "+t(e[c],e)):n.push(c+": "+t(e[c],e))));if("function"==typeof mr)for(var s=0;s<i.length;s++)Or.call(e,i[s])&&n.push("["+t(i[s])+"]: "+t(e[i[s]],e));return n}var an=$t,un=Yt,cn=xr,sn=an("%TypeError%"),fn=an("%WeakMap%",!0),ln=an("%Map%",!0),pn=un("WeakMap.prototype.get",!0),yn=un("WeakMap.prototype.set",!0),dn=un("WeakMap.prototype.has",!0),hn=un("Map.prototype.get",!0),bn=un("Map.prototype.set",!0),vn=un("Map.prototype.has",!0),gn=function(e,t){for(var r=e,n;null!==(n=r.next);r=n)if(n.key===t)return r.next=n.next,n.next=e.next,e.next=n,n},mn=function(e,t){var r=gn(e,t);return r&&r.value},wn=function(e,t,r){var n=gn(e,t);n?n.value=r:e.next={key:t,next:e.next,value:r}},Sn=function(e,t){return!!gn(e,t)},On=function e(){var t,r,n,o={assert:function(e){if(!o.has(e))throw new sn("Side channel does not contain "+cn(e))},get:function(e){if(fn&&e&&("object"==typeof e||"function"==typeof e)){if(t)return pn(t,e)}else if(ln){if(r)return hn(r,e)}else if(n)return mn(n,e)},has:function(e){if(fn&&e&&("object"==typeof e||"function"==typeof e)){if(t)return dn(t,e)}else if(ln){if(r)return vn(r,e)}else if(n)return Sn(n,e);return!1},set:function(e,o){fn&&e&&("object"==typeof e||"function"==typeof e)?(t||(t=new fn),yn(t,e,o)):ln?(r||(r=new ln),bn(r,e,o)):(n||(n={key:{},next:null}),wn(n,e,o))}};return o},jn=String.prototype.replace,Pn=/%20/g,An,En="RFC3986",xn={default:En,formatters:{RFC1738:function(e){return jn.call(e,Pn,"+")},RFC3986:function(e){return String(e)}},RFC1738:"RFC1738",RFC3986:En},_n=xn,kn=Object.prototype.hasOwnProperty,Tn=Array.isArray,In=function(){for(var e=[],t=0;t<256;++t)e.push("%"+((t<16?"0":"")+t.toString(16)).toUpperCase());return e}(),Rn=function e(t){for(;t.length>1;){var r=t.pop(),n=r.obj[r.prop];if(Tn(n)){for(var o=[],i=0;i<n.length;++i)"undefined"!=typeof n[i]&&o.push(n[i]);r.obj[r.prop]=o}}},Cn=function e(t,r){for(var n=r&&r.plainObjects?Object.create(null):{},o=0;o<t.length;++o)"undefined"!=typeof t[o]&&(n[o]=t[o]);return n},Fn=function e(t,r,n){if(!r)return t;if("object"!=typeof r){if(Tn(t))t.push(r);else{if(!t||"object"!=typeof t)return[t,r];(n&&(n.plainObjects||n.allowPrototypes)||!kn.call(Object.prototype,r))&&(t[r]=!0)}return t}if(!t||"object"!=typeof t)return[t].concat(r);var o=t;return Tn(t)&&!Tn(r)&&(o=Cn(t,n)),Tn(t)&&Tn(r)?(r.forEach((function(r,o){if(kn.call(t,o)){var i=t[o];i&&"object"==typeof i&&r&&"object"==typeof r?t[o]=e(i,r,n):t.push(r)}else t[o]=r})),t):Object.keys(r).reduce((function(t,o){var i=r[o];return kn.call(t,o)?t[o]=e(t[o],i,n):t[o]=i,t}),o)},Dn,Ln,Nn,Mn,Un,qn,Bn,Wn,Hn={arrayToObject:Cn,assign:function e(t,r){return Object.keys(r).reduce((function(e,t){return e[t]=r[t],e}),t)},combine:function e(t,r){return[].concat(t,r)},compact:function e(t){for(var r=[{obj:{o:t},prop:"o"}],n=[],o=0;o<r.length;++o)for(var i=r[o],a=i.obj[i.prop],u=Object.keys(a),c=0;c<u.length;++c){var s=u[c],f=a[s];"object"==typeof f&&null!==f&&-1===n.indexOf(f)&&(r.push({obj:a,prop:s}),n.push(f))}return Rn(r),t},decode:function(e,t,r){var n=e.replace(/\+/g," ");if("iso-8859-1"===r)return n.replace(/%[0-9a-f]{2}/gi,unescape);try{return decodeURIComponent(n)}catch(e){return n}},encode:function e(t,r,n,o,i){if(0===t.length)return t;var a=t;if("symbol"==typeof t?a=Symbol.prototype.toString.call(t):"string"!=typeof t&&(a=String(t)),"iso-8859-1"===n)return escape(a).replace(/%u[0-9a-f]{4}/gi,(function(e){return"%26%23"+parseInt(e.slice(2),16)+"%3B"}));for(var u="",c=0;c<a.length;++c){var s=a.charCodeAt(c);45===s||46===s||95===s||126===s||s>=48&&s<=57||s>=65&&s<=90||s>=97&&s<=122||i===_n.RFC1738&&(40===s||41===s)?u+=a.charAt(c):s<128?u+=In[s]:s<2048?u+=In[192|s>>6]+In[128|63&s]:s<55296||s>=57344?u+=In[224|s>>12]+In[128|s>>6&63]+In[128|63&s]:(c+=1,s=65536+((1023&s)<<10|1023&a.charCodeAt(c)),u+=In[240|s>>18]+In[128|s>>12&63]+In[128|s>>6&63]+In[128|63&s])}return u},isBuffer:function e(t){return!(!t||"object"!=typeof t)&&!!(t.constructor&&t.constructor.isBuffer&&t.constructor.isBuffer(t))},isRegExp:function e(t){return"[object RegExp]"===Object.prototype.toString.call(t)},maybeMap:function e(t,r){if(Tn(t)){for(var n=[],o=0;o<t.length;o+=1)n.push(r(t[o]));return n}return r(t)},merge:Fn},Gn=On,$n=Hn,zn=xn,Vn=Object.prototype.hasOwnProperty,Qn={brackets:function e(t){return t+"[]"},comma:"comma",indices:function e(t,r){return t+"["+r+"]"},repeat:function e(t){return t}},Jn=Array.isArray,Yn=Array.prototype.push,Kn=function(e,t){Yn.apply(e,Jn(t)?t:[t])},Xn=Date.prototype.toISOString,Zn=zn.default,eo={addQueryPrefix:!1,allowDots:!1,charset:"utf-8",charsetSentinel:!1,delimiter:"&",encode:!0,encoder:$n.encode,encodeValuesOnly:!1,format:Zn,formatter:zn.formatters[Zn],indices:!1,serializeDate:function e(t){return Xn.call(t)},skipNulls:!1,strictNullHandling:!1},to=function e(t){return"string"==typeof t||"number"==typeof t||"boolean"==typeof t||"symbol"==typeof t||"bigint"==typeof t},ro=function e(t,r,n,o,i,a,u,c,s,f,l,p,y,d,h){var b=t,v;if(h.has(t))throw new RangeError("Cyclic object value");if("function"==typeof u?b=u(r,b):b instanceof Date?b=f(b):"comma"===n&&Jn(b)&&(b=$n.maybeMap(b,(function(e){return e instanceof Date?f(e):e}))),null===b){if(o)return a&&!y?a(r,eo.encoder,d,"key",l):r;b=""}if(to(b)||$n.isBuffer(b))return a?[p(y?r:a(r,eo.encoder,d,"key",l))+"="+p(a(b,eo.encoder,d,"value",l))]:[p(r)+"="+p(String(b))];var g=[],m;if("undefined"==typeof b)return g;if("comma"===n&&Jn(b))m=[{value:b.length>0?b.join(",")||null:void 0}];else if(Jn(u))m=u;else{var w=Object.keys(b);m=c?w.sort(c):w}for(var S=0;S<m.length;++S){var O=m[S],j="object"==typeof O&&void 0!==O.value?O.value:b[O];if(!i||null!==j){var P=Jn(b)?"function"==typeof n?n(r,O):r:r+(s?"."+O:"["+O+"]");h.set(t,!0);var A=Gn();Kn(g,e(j,P,n,o,i,a,u,c,s,f,l,p,y,d,A))}}return g},no=function e(t){if(!t)return eo;if(null!==t.encoder&&void 0!==t.encoder&&"function"!=typeof t.encoder)throw new TypeError("Encoder has to be a function.");var r=t.charset||eo.charset;if("undefined"!=typeof t.charset&&"utf-8"!==t.charset&&"iso-8859-1"!==t.charset)throw new TypeError("The charset option must be either utf-8, iso-8859-1, or undefined");var n=zn.default;if("undefined"!=typeof t.format){if(!Vn.call(zn.formatters,t.format))throw new TypeError("Unknown format option provided.");n=t.format}var o=zn.formatters[n],i=eo.filter;return("function"==typeof t.filter||Jn(t.filter))&&(i=t.filter),{addQueryPrefix:"boolean"==typeof t.addQueryPrefix?t.addQueryPrefix:eo.addQueryPrefix,allowDots:"undefined"==typeof t.allowDots?eo.allowDots:!!t.allowDots,charset:r,charsetSentinel:"boolean"==typeof t.charsetSentinel?t.charsetSentinel:eo.charsetSentinel,delimiter:"undefined"==typeof t.delimiter?eo.delimiter:t.delimiter,encode:"boolean"==typeof t.encode?t.encode:eo.encode,encoder:"function"==typeof t.encoder?t.encoder:eo.encoder,encodeValuesOnly:"boolean"==typeof t.encodeValuesOnly?t.encodeValuesOnly:eo.encodeValuesOnly,filter:i,format:n,formatter:o,serializeDate:"function"==typeof t.serializeDate?t.serializeDate:eo.serializeDate,skipNulls:"boolean"==typeof t.skipNulls?t.skipNulls:eo.skipNulls,sort:"function"==typeof t.sort?t.sort:null,strictNullHandling:"boolean"==typeof t.strictNullHandling?t.strictNullHandling:eo.strictNullHandling}},oo=function(e,t){var r=e,n=no(t),o,i;"function"==typeof n.filter?r=(i=n.filter)("",r):Jn(n.filter)&&(o=i=n.filter);var a=[],u;if("object"!=typeof r||null===r)return"";u=t&&t.arrayFormat in Qn?t.arrayFormat:t&&"indices"in t?t.indices?"indices":"repeat":"indices";var c=Qn[u];o||(o=Object.keys(r)),n.sort&&o.sort(n.sort);for(var s=Gn(),f=0;f<o.length;++f){var l=o[f];n.skipNulls&&null===r[l]||Kn(a,ro(r[l],l,c,n.strictNullHandling,n.skipNulls,n.encode?n.encoder:null,n.filter,n.sort,n.allowDots,n.serializeDate,n.format,n.formatter,n.encodeValuesOnly,n.charset,s))}var p=a.join(n.delimiter),y=!0===n.addQueryPrefix?"?":"";return n.charsetSentinel&&("iso-8859-1"===n.charset?y+="utf8=%26%2310003%3B&":y+="utf8=%E2%9C%93&"),p.length>0?y+p:""},io=Hn,ao=Object.prototype.hasOwnProperty,uo=Array.isArray,co={allowDots:!1,allowPrototypes:!1,allowSparse:!1,arrayLimit:20,charset:"utf-8",charsetSentinel:!1,comma:!1,decoder:io.decode,delimiter:"&",depth:5,ignoreQueryPrefix:!1,interpretNumericEntities:!1,parameterLimit:1e3,parseArrays:!0,plainObjects:!1,strictNullHandling:!1},so=function(e){return e.replace(/&#(\d+);/g,(function(e,t){return String.fromCharCode(parseInt(t,10))}))},fo=function(e,t){return e&&"string"==typeof e&&t.comma&&e.indexOf(",")>-1?e.split(","):e},lo="utf8=%26%2310003%3B",po="utf8=%E2%9C%93",yo=function e(t,r){var n={},o=r.ignoreQueryPrefix?t.replace(/^\?/,""):t,i=r.parameterLimit===1/0?void 0:r.parameterLimit,a=o.split(r.delimiter,i),u=-1,c,s=r.charset;if(r.charsetSentinel)for(c=0;c<a.length;++c)0===a[c].indexOf("utf8=")&&(a[c]===po?s="utf-8":a[c]===lo&&(s="iso-8859-1"),u=c,c=a.length);for(c=0;c<a.length;++c)if(c!==u){var f=a[c],l=f.indexOf("]="),p=-1===l?f.indexOf("="):l+1,y,d;-1===p?(y=r.decoder(f,co.decoder,s,"key"),d=r.strictNullHandling?null:""):(y=r.decoder(f.slice(0,p),co.decoder,s,"key"),d=io.maybeMap(fo(f.slice(p+1),r),(function(e){return r.decoder(e,co.decoder,s,"value")}))),d&&r.interpretNumericEntities&&"iso-8859-1"===s&&(d=so(d)),f.indexOf("[]=")>-1&&(d=uo(d)?[d]:d),ao.call(n,y)?n[y]=io.combine(n[y],d):n[y]=d}return n},ho=function(e,t,r,n){for(var o=n?t:fo(t,r),i=e.length-1;i>=0;--i){var a,u=e[i];if("[]"===u&&r.parseArrays)a=[].concat(o);else{a=r.plainObjects?Object.create(null):{};var c="["===u.charAt(0)&&"]"===u.charAt(u.length-1)?u.slice(1,-1):u,s=parseInt(c,10);r.parseArrays||""!==c?!isNaN(s)&&u!==c&&String(s)===c&&s>=0&&r.parseArrays&&s<=r.arrayLimit?(a=[])[s]=o:a[c]=o:a={0:o}}o=a}return o},bo=function e(t,r,n,o){if(t){var i=n.allowDots?t.replace(/\.([^.[]+)/g,"[$1]"):t,a=/(\[[^[\]]*])/,u=/(\[[^[\]]*])/g,c=n.depth>0&&a.exec(i),s=c?i.slice(0,c.index):i,f=[];if(s){if(!n.plainObjects&&ao.call(Object.prototype,s)&&!n.allowPrototypes)return;f.push(s)}for(var l=0;n.depth>0&&null!==(c=u.exec(i))&&l<n.depth;){if(l+=1,!n.plainObjects&&ao.call(Object.prototype,c[1].slice(1,-1))&&!n.allowPrototypes)return;f.push(c[1])}return c&&f.push("["+i.slice(c.index)+"]"),ho(f,r,n,o)}},vo=function e(t){if(!t)return co;if(null!==t.decoder&&void 0!==t.decoder&&"function"!=typeof t.decoder)throw new TypeError("Decoder has to be a function.");if("undefined"!=typeof t.charset&&"utf-8"!==t.charset&&"iso-8859-1"!==t.charset)throw new TypeError("The charset option must be either utf-8, iso-8859-1, or undefined");var r="undefined"==typeof t.charset?co.charset:t.charset;return{allowDots:"undefined"==typeof t.allowDots?co.allowDots:!!t.allowDots,allowPrototypes:"boolean"==typeof t.allowPrototypes?t.allowPrototypes:co.allowPrototypes,allowSparse:"boolean"==typeof t.allowSparse?t.allowSparse:co.allowSparse,arrayLimit:"number"==typeof t.arrayLimit?t.arrayLimit:co.arrayLimit,charset:r,charsetSentinel:"boolean"==typeof t.charsetSentinel?t.charsetSentinel:co.charsetSentinel,comma:"boolean"==typeof t.comma?t.comma:co.comma,decoder:"function"==typeof t.decoder?t.decoder:co.decoder,delimiter:"string"==typeof t.delimiter||io.isRegExp(t.delimiter)?t.delimiter:co.delimiter,depth:"number"==typeof t.depth||!1===t.depth?+t.depth:co.depth,ignoreQueryPrefix:!0===t.ignoreQueryPrefix,interpretNumericEntities:"boolean"==typeof t.interpretNumericEntities?t.interpretNumericEntities:co.interpretNumericEntities,parameterLimit:"number"==typeof t.parameterLimit?t.parameterLimit:co.parameterLimit,parseArrays:!1!==t.parseArrays,plainObjects:"boolean"==typeof t.plainObjects?t.plainObjects:co.plainObjects,strictNullHandling:"boolean"==typeof t.strictNullHandling?t.strictNullHandling:co.strictNullHandling}},go,mo,wo,So,Oo={formats:xn,parse:function(e,t){var r=vo(t);if(""===e||null===e||"undefined"==typeof e)return r.plainObjects?Object.create(null):{};for(var n="string"==typeof e?yo(e,r):e,o=r.plainObjects?Object.create(null):{},i=Object.keys(n),a=0;a<i.length;++a){var u=i[a],c=bo(u,n[u],r,"string"==typeof e);o=io.merge(o,c,r)}return!0===r.allowSparse?o:io.compact(o)},stringify:oo},jo;function Po(e,t){if(t&&"object"==typeof t&&Object.keys(t).length){const r=Oo.stringify(t);return e.includes("?")?`${e}&${r}`:`${e}?${r}`}return e}function Ao(e){const t=Object.assign({},e),r={};return"undefined"!=typeof t.cookies&&(r.cookies=t.cookies),delete t.cookies,t.abortController&&"function"==typeof t.abortController.abort&&(r.abortController=t.abortController),delete t.abortController,"undefined"!=typeof t.contentType&&(r.contentType=t.contentType),delete t.contentType,"undefined"!=typeof t.data&&(r.data=t.data),delete t.data,t.dataType&&(r.dataType=t.dataType),delete t.dataType,t.fetchModule&&(r.fetchModule=t.fetchModule),delete t.fetchModule,t.headersInitClass&&(r.headersInitClass=t.headersInitClass),delete t.headersInitClass,"undefined"!=typeof t.keepRedirectCookies&&(r.keepRedirectCookies=!!t.keepRedirectCookies),delete t.keepRedirectCookies,"undefined"!=typeof t.processData&&(r.processData=t.processData),delete t.processData,"undefined"!=typeof t.timeout&&(r.timeout=t.timeout),delete t.timeout,{args:r,requestInit:Object.assign({},t)}}function Eo(e){let t=Object.assign({},e);return t=xo(t),t=_o(t),t=ko(t),t=To(t),t.args.dataType=Io(t.args.dataType),t.args.timeout=Ro(t.args.timeout),t.requestInit.redirect=Co(t.args.keepRedirectCookies,t.requestInit.redirect),t}function xo(e){const{args:t,requestInit:r}=e;if(t.headersInitClass){const e=r.headers?new t.headersInitClass(r.headers):new t.headersInitClass;r.headers=e}else{if("function"!=typeof Headers)throw new TypeError('parseHeaders(): Headers Class undefined.\nIf running under Node.js, it must pass HeaderClass such come from package "node-fetch".');r.headers=r.headers?new Headers(r.headers):new Headers}const{headers:n}=r;return n.has("Accept")||n.set("Accept","application/json, text/html, text/javascript, text/plain, */*"),{args:t,requestInit:r}}function _o(e){const{args:t,requestInit:r}=e;return t.abortController&&t.abortController.signal&&"function"==typeof t.abortController.abort||(t.abortController="function"==typeof AbortController?new AbortController:new Ye),t.abortController&&(r.signal=t.abortController.signal),{args:t,requestInit:r}}function ko(e){const{args:t,requestInit:r}=e,n=t.cookies,o=[];if(n&&"object"==typeof n)for(let[e,t]of Object.entries(n))if(e&&"string"==typeof e){if(e=e.trim(),!e)continue;t="string"==typeof t||"number"==typeof t?t.toString().trim():"",o.push(`${e}=${t}`)}if(o.length){const e=r.headers;let t=e.get("Cookie");if(t){t=t.trim();let r=o.join("; ");t.endsWith(";")?(t=t.slice(0,-1),r=`${t}; `+r):r=`${t}; `+r,e.set("Cookie",r)}else e.set("Cookie",o.join("; "))}return{args:t,requestInit:r}}function To(t){const{args:r,requestInit:n}=t;if(n.method&&["DELETE","POST","PUT"].includes(n.method)){const t=n.headers;!1===r.contentType||(r.contentType?t.set("Content-Type",r.contentType):t.has("Content-Type")||t.set("Content-Type",e.ContentTypeList.json))}return{args:r,requestInit:n}}function Io(e){return"string"==typeof e&&["arrayBuffer","bare","blob","formData","json","text","raw"].includes(e)?e:"json"}function Ro(e){const t="number"==typeof e&&e>=0?Math.ceil(e):null;return null!==t&&Number.isSafeInteger(t)?t:null}function Co(e,t){return!0===e&&"undefined"==typeof window&&"follow"===t?"manual":t||"follow"}function Fo(e){let t=null;return e?("function"!=typeof e&&we((()=>new TypeError("fetchModule is not Function"))),t=e):"function"==typeof fetch?t=fetch:we((()=>new TypeError("fetchModule/fetch not Function"))),t}function Do(e,t){let r="";if("undefined"==typeof t.data)r=e;else{if(!t.processData)throw new TypeError("Typeof args.data invalid for GET/DELETE when args.processData not true, type is :"+typeof t.data);r=Po(e,t.data)}return r}function Lo(e){let t;const{data:r}=e;return"string"==typeof r?t=r:"undefined"==typeof r||null===r||(t="undefined"!=typeof FormData&&r instanceof FormData||"undefined"!=typeof at&&r instanceof at||"undefined"!=typeof Blob&&r instanceof Blob||"undefined"!=typeof ArrayBuffer&&r instanceof ArrayBuffer||"undefined"!=typeof URLSearchParams&&r instanceof URLSearchParams||"undefined"!=typeof ReadableStream&&r instanceof ReadableStream?r:e.processData&&e.contentType&&e.contentType.includes("json")?JSON.stringify(r):e.processData?Oo.stringify(r):r),t}function No(e,t,r){e||we((()=>new TypeError("value of input invalid")));let n=Mo(e,t,r);return n=Uo(n,t),n.pipe(Te((e=>Bo(e,t,r))))}function Mo(e,t,r){let n=e;const o=Fo(t.fetchModule);if("string"==typeof e){if(["GET","DELETE"].includes(r.method))n=Do(e,t);else{if(!["POST","PUT","OPTIONS"].includes(r.method))throw new TypeError(`Invalid method value: "${r.method}"`);{const e=Lo(t);"undefined"!=typeof e&&(r.body=e)}}return _e((()=>o(n,r)))}return _e((()=>o(e)))}function Uo(e,t){const r=undefined;return qo(e,t.timeout,t.abortController)}function qo(e,t,r){let n=e;return"number"==typeof t&&t>=0&&(n=e.pipe(je(t),ke((e=>{throw r&&"function"==typeof r.abort&&!r.signal.aborted&&r.abort(),e})))),n}function Bo(e,t,r){if(!0===t.keepRedirectCookies&&e.status>=301&&e.status<=308){const n=e.headers.get("location"),o=e.headers.get("Set-Cookie");if(n){const i=it(o);i&&(t.cookies=t.cookies?Object.assign(Object.assign({},t.cookies),i):Object.assign({},i));const a=Eo({args:t,requestInit:r});return 303===e.status?(a.requestInit.method="GET",No(n,a.args,a.requestInit)):No(n,a.args,a.requestInit)}}else we((()=>"Redirect location is empty"));return me(e)}function Wo(e,t){e||we((()=>new TypeError("value of input invalid")));const r=undefined,n=Ao(t?Object.assign(Object.assign({},et),t):Object.assign({},et)),{args:o,requestInit:i}=Eo(n),a=o.dataType,u=undefined,c=undefined;return No(e,o,i).pipe(Te((e=>nt(e,"bare"===a))),Te((e=>ot(e,a))))}function Ho(e,t){const r=undefined;return Wo(e,t?Object.assign(Object.assign({},t),{method:"GET"}):{method:"GET"})}function Go(e,t){const r=undefined;return Wo(e,t?Object.assign(Object.assign({},t),{method:"POST"}):{method:"POST"})}function $o(e,t){const r=undefined;return Wo(e,t?Object.assign(Object.assign({},t),{method:"PUT"}):{method:"PUT"})}function zo(e,t){const r=undefined;return Wo(e,t?Object.assign(Object.assign({},t),{method:"DELETE"}):{method:"DELETE"})}function Vo(e){for(const[t,r]of Object.entries(e))Object.defineProperty(et,t,{configurable:!0,enumerable:!0,writable:!0,value:r})}function Qo(){return Object.assign({},et)}e.ContentTypeList=void 0,(jo=e.ContentTypeList||(e.ContentTypeList={})).formDataPartial="multipart/form-data; boundary=",jo.formUrlencoded="application/x-www-form-urlencoded; charset=utf-8",jo.html="text/html; charset=utf-8",jo.json="application/json; charset=utf-8",jo.plain="text/plain",e.buildQueryString=Po,e.fetch=Wo,e.get=Ho,e.getGloalRequestInit=Qo,e.parseInitOpts=Eo,e.parseRequestGetLikeData=Do,e.parseRequestPostLikeData=Lo,e.parseRespCookie=it,e.post=Go,e.put=$o,e.remove=zo,e.rxfetch=Wo,e.selectFecthModule=Fo,e.setGloalRequestInit=Vo,e.splitInitArgs=Ao,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=rxxfetch.umd.min.js.map
